var eventproxy = require('eventproxy');
var superagent = require('superagent');
var cheerio = require('cheerio');
var express = require('express');
var ejs = require('ejs');
var url = require('url');
var http = require('http');
var path = require('path');

var app = express();


/**
 * 返回每一页小姐的页面连接
 * @param Object $  类似jQuery的操作对象
 * return Array
 */
function xjjPage($) {
    var url = [];
    $('#postlist>.pin>.pin-coat>a').each((i, e) => {
        var $e = $(e);
        var href = $e.attr('href');
        //var href = url.resolve(uri, $e.attr('href'));
        url.push(href);
    });
    return url;
}

/**
 * 实际操作函数
 * return Array
 */
function Data(q) {
    superagent.get(uri).end((err, res) => {
        if (err) {
            return console.error(err);
        }

        var $ = cheerio.load(res.text);

        var xjjUrls = xjjPage($);

        //var xjjUrls = ['http://www.jdlingyu.moe/28728/'];

        //console.log(xjjUrls);

        var ep = new eventproxy();
        var xjj_len = xjjUrls.length;  // 定义每页小姐姐的数量
        ep.after('xjj', xjj_len, (xjjImgs) => {
            xjjImgs = xjjImgs.map((topicPair) => {
                var topicUrl = topicPair[0];
                var topicHTML = topicPair[1];
                var $ = cheerio.load(topicHTML);
                var info = $('.image');
                var $title = info.find('.main-title').text();
                var $href = topicUrl;
                var imgUrls = [];
                var imgBody = info.find('.main-body>p a');
                var $imgs = imgBody.each((i, e) => {
                    var e = $(e);
                    imgUrls.push(e.attr('href'));
                });

                return ({
                    title: $title,
                    href: $href,
                    imgs: imgUrls
                });
            });

            q.send(xjjImgs);
        });

        xjjUrls.forEach((xjjUri) => {
            superagent.get(xjjUri).end((err, res) => {
                console.log('fetch ' + xjjUri + ' successful');
                ep.emit('xjj', [xjjUri, res.text]);
            });
        });

    });

}

// 启动函数
function init() {
    app.set('views', path.join(__dirname, 'views'));
    app.set('view engine', 'ejs');

    // 同步输出好蛋疼，当作一个接口 ajax 调用数据把
    app.get('/api*', function (req, res) {
        res.setHeader('content-type','application/json');
        Data(res);
    });

    app.get('/', function (req, res) {
        res.render('index');
    });

    app.listen(port, (req, res) => {
        console.log(`127.0.0.1:${port} running`);
    });
}




// 定义端口
var port = 3000;
// 定义要扒小姐姐的网址
var uri = 'http://www.jdlingyu.moe/';
// 启动，令克斯塔偷
init();

